globals
[
  red-crossed
  blue-crossed
  yellow-crossed
  green-crossed
  sidewalk-list1
  sidewalk-list2
  sidewalk-list3
  sidewalk-list4
  sidewalk-list5
  shortcut-value
]

to setup
  clear-all
  clear-output
  ask patches [
    if pxcor = min-pxcor and pycor = min-pycor ; at bottom left corner, spawn red agents
    [
      sprout (pedestrians / 4)
      [
        set shape "person"
        set size 3
        set color red
      ]
      ask [turtles-at 9 9] of patch min-pxcor min-pycor
      [
        setxy (min-pxcor + random-float 9) (min-pycor + random-float 9)
      ]
    ]
    if pxcor = max-pxcor and pycor = min-pycor ; at bottom right corner, spawn blue agents
    [
      sprout (pedestrians / 4)
      [
        set shape "person"
        set size 3
        set color blue
      ]
      ask [turtles-at 9 9] of patch max-pxcor min-pycor
      [
        setxy (max-pxcor - random-float 9) (min-pycor + random-float 9)
      ]
    ]
    if pxcor = max-pxcor and pycor = max-pycor ; at top right corner, spawn green agents
    [
      sprout (pedestrians / 4)
      [
        set shape "person"
        set size 3
        set color green
      ]
      ask [turtles-at 9 9] of patch max-pxcor max-pycor
      [
        setxy (max-pxcor - random-float 9) (max-pycor - random-float 9)
      ]
    ]
    if pxcor = min-pxcor and pycor = max-pycor ; at top left corner, spawn yellow agents
    [
      sprout (pedestrians / 4)
      [
        set shape "person"
        set size 3
        set color yellow
      ]
    ]
  ]
 ask patches
  [
    if pxcor > 20 and pycor > 20 [set pcolor pink] ; Q1 Color
    if pxcor < 20 and pycor > 20 [set pcolor turquoise] ; Q2 Color
    if pxcor > 20 and pycor < 20 [set pcolor orange] ; Q3 Color
    if pxcor < 20 and pycor < 20 [set pcolor lime] ; Q4 Color
    if (pxcor <= 20 and pxcor >= -20) or (pycor <= 20 and pycor >= -20) [set pcolor grey]; Road
  ]
  set sidewalk-list1 (patch-set (patch -21 -19) (patch -21 -17) (patch -21 -15) (patch -21 -13) (patch -21 -11) (patch -21 -9) (patch -21 -7) (patch -21 -5) (patch -21 -3) (patch -21 -1) (patch -21 1) (patch -21 3) (patch -21 5) (patch -21 7) (patch -21 9) (patch -21 11) (patch -21 13) (patch -21 15) (patch -21 17) (patch -21 19) (patch -22 -19) (patch -22 -17) (patch -22 -15) (patch -22 -13) (patch -22 -11) (patch -22 -9) (patch -22 -7) (patch -22 -5) (patch -22 -3) (patch -22 -1) (patch -22 1) (patch -22 3) (patch -22 5) (patch -22 7) (patch -22 9) (patch -22 11) (patch -22 13) (patch -22 15) (patch -22 17) (patch -22 19) (patch -23 -19) (patch -23 -17) (patch -23 -15) (patch -23 -13) (patch -23 -11) (patch -23 -9) (patch -23 -7) (patch -23 -5) (patch -23 -3) (patch -23 -1) (patch -23 1) (patch -23 3) (patch -23 5) (patch -23 7) (patch -23 9) (patch -23 11) (patch -23 13) (patch -23 15) (patch -23 17) (patch -23 19) (patch -24 -19) (patch -24 -17) (patch -24 -15) (patch -24 -13) (patch -24 -11) (patch -24 -9) (patch -24 -7) (patch -24 -5) (patch -24 -3) (patch -24 -1) (patch -24 1) (patch -24 3) (patch -24 5) (patch -24 7) (patch -24 9) (patch -24 11) (patch -24 13) (patch -24 15) (patch -24 17) (patch -24 19) (patch -25 -19) (patch -25 -17) (patch -25 -15) (patch -25 -13) (patch -25 -11) (patch -25 -9) (patch -25 -7) (patch -25 -5) (patch -25 -3) (patch -25 -1) (patch -25 1) (patch -25 3) (patch -25 5) (patch -25 7) (patch -25 9) (patch -25 11) (patch -25 13) (patch -25 15) (patch -25 17) (patch -25 19) (patch -26 -19) (patch -26 -17) (patch -26 -15) (patch -26 -13) (patch -26 -11) (patch -26 -9) (patch -26 -7) (patch -26 -5) (patch -26 -3) (patch -26 -1) (patch -26 1) (patch -26 3) (patch -26 5) (patch -26 7) (patch -26 9) (patch -26 11) (patch -26 13) (patch -26 15) (patch -26 17) (patch -26 19) (patch -27 -19) (patch -27 -17) (patch -27 -15) (patch -27 -13) (patch -27 -11) (patch -27 -9) (patch -27 -7) (patch -27 -5) (patch -27 -3) (patch -27 -1) (patch -27 1) (patch -27 3) (patch -27 5) (patch -27 7) (patch -27 9) (patch -27 11) (patch -27 13) (patch -27 15) (patch -27 17) (patch -27 19) (patch -28 -19) (patch -28 -17) (patch -28 -15) (patch -28 -13) (patch -28 -11) (patch -28 -9) (patch -28 -7) (patch -28 -5) (patch -28 -3) (patch -28 -1) (patch -28 1) (patch -28 3) (patch -28 5) (patch -28 7) (patch -28 9) (patch -28 11) (patch -28 13) (patch -28 15) (patch -28 17) (patch -28 19) (patch -29 -19) (patch -29 -17) (patch -29 -15) (patch -29 -13) (patch -29 -11) (patch -29 -9) (patch -29 -7) (patch -29 -5) (patch -29 -3) (patch -29 -1) (patch -29 1) (patch -29 3) (patch -29 5) (patch -29 7) (patch -29 9) (patch -29 11) (patch -29 13) (patch -29 15) (patch -29 17) (patch -29 19) (patch -30 -19) (patch -30 -17) (patch -30 -15) (patch -30 -13) (patch -30 -11) (patch -30 -9) (patch -30 -7) (patch -30 -5) (patch -30 -3) (patch -30 -1) (patch -30 1) (patch -30 3) (patch -30 5) (patch -30 7) (patch -30 9) (patch -30 11) (patch -30 13) (patch -30 15) (patch -30 17) (patch -30 19))
  set sidewalk-list2 (patch-set (patch 21 -19) (patch 21 -17) (patch 21 -15) (patch 21 -13) (patch 21 -11) (patch 21 -9) (patch 21 -7) (patch 21 -5) (patch 21 -3) (patch 21 -1) (patch 21 1) (patch 21 3) (patch 21 5) (patch 21 7) (patch 21 9) (patch 21 11) (patch 21 13) (patch 21 15) (patch 21 17) (patch 21 19) (patch 22 -19) (patch 22 -17) (patch 22 -15) (patch 22 -13) (patch 22 -11) (patch 22 -9) (patch 22 -7) (patch 22 -5) (patch 22 -3) (patch 22 -1) (patch 22 1) (patch 22 3) (patch 22 5) (patch 22 7) (patch 22 9) (patch 22 11) (patch 22 13) (patch 22 15) (patch 22 17) (patch 22 19) (patch 23 -19) (patch 23 -17) (patch 23 -15) (patch 23 -13) (patch 23 -11) (patch 23 -9) (patch 23 -7) (patch 23 -5) (patch 23 -3) (patch 23 -1) (patch 23 1) (patch 23 3) (patch 23 5) (patch 23 7) (patch 23 9) (patch 23 11) (patch 23 13) (patch 23 15) (patch 23 17) (patch 23 19) (patch 24 -19) (patch 24 -17) (patch 24 -15) (patch 24 -13) (patch 24 -11) (patch 24 -9) (patch 24 -7) (patch 24 -5) (patch 24 -3) (patch 24 -1) (patch 24 1) (patch 24 3) (patch 24 5) (patch 24 7) (patch 24 9) (patch 24 11) (patch 24 13) (patch 24 15) (patch 24 17) (patch 24 19) (patch 25 -19) (patch 25 -17) (patch 25 -15) (patch 25 -13) (patch 25 -11) (patch 25 -9) (patch 25 -7) (patch 25 -5) (patch 25 -3) (patch 25 -1) (patch 25 1) (patch 25 3) (patch 25 5) (patch 25 7) (patch 25 9) (patch 25 11) (patch 25 13) (patch 25 15) (patch 25 17) (patch 25 19) (patch 26 -19) (patch 26 -17) (patch 26 -15) (patch 26 -13) (patch 26 -11) (patch 26 -9) (patch 26 -7) (patch 26 -5) (patch 26 -3) (patch 26 -1) (patch 26 1) (patch 26 3) (patch 26 5) (patch 26 7) (patch 26 9) (patch 26 11) (patch 26 13) (patch 26 15) (patch 26 17) (patch 26 19) (patch 27 -19) (patch 27 -17) (patch 27 -15) (patch 27 -13) (patch 27 -11) (patch 27 -9) (patch 27 -7) (patch 27 -5) (patch 27 -3) (patch 27 -1) (patch 27 1) (patch 27 3) (patch 27 5) (patch 27 7) (patch 27 9) (patch 27 11) (patch 27 13) (patch 27 15) (patch 27 17) (patch 27 19) (patch 28 -19) (patch 28 -17) (patch 28 -15) (patch 28 -13) (patch 28 -11) (patch 28 -9) (patch 28 -7) (patch 28 -5) (patch 28 -3) (patch 28 -1) (patch 28 1) (patch 28 3) (patch 28 5) (patch 28 7) (patch 28 9) (patch 28 11) (patch 28 13) (patch 28 15) (patch 28 17) (patch 28 19) (patch 29 -19) (patch 29 -17) (patch 29 -15) (patch 29 -13) (patch 29 -11) (patch 29 -9) (patch 29 -7) (patch 29 -5) (patch 29 -3) (patch 29 -1) (patch 29 1) (patch 29 3) (patch 29 5) (patch 29 7) (patch 29 9) (patch 29 11) (patch 29 13) (patch 29 15) (patch 29 17) (patch 29 19) (patch 30 -19) (patch 30 -17) (patch 30 -15) (patch 30 -13) (patch 30 -11) (patch 30 -9) (patch 30 -7) (patch 30 -5) (patch 30 -3) (patch 30 -1) (patch 30 1) (patch 30 3) (patch 30 5) (patch 30 7) (patch 30 9) (patch 30 11) (patch 30 13) (patch 30 15) (patch 30 17) (patch 30 19))
  set sidewalk-list3 (patch-set (patch -19 21) (patch -17 21) (patch -15 21) (patch -13 21) (patch -11 21) (patch -9 21) (patch -7 21) (patch -5 21) (patch -3 21) (patch -1 21) (patch 1 21) (patch 3 21) (patch 5 21) (patch 7 21) (patch 9 21) (patch 11 21) (patch 13 21) (patch 15 21) (patch 17 21) (patch 19 21) (patch -19 22) (patch -17 22) (patch -15 22) (patch -13 22) (patch -11 22) (patch -9 22) (patch -7 22) (patch -5 22) (patch -3 22) (patch -1 22) (patch 1 22) (patch 3 22) (patch 5 22) (patch 7 22) (patch 9 22) (patch 11 22) (patch 13 22) (patch 15 22) (patch 17 22) (patch 19 22) (patch -19 23) (patch -17 23) (patch -15 23) (patch -13 23) (patch -11 23) (patch -9 23) (patch -7 23) (patch -5 23) (patch -3 23) (patch -1 23) (patch 1 23) (patch 3 23) (patch 5 23) (patch 7 23) (patch 9 23) (patch 11 23) (patch 13 23) (patch 15 23) (patch 17 23) (patch 19 23) (patch -19 24) (patch -17 24) (patch -15 24) (patch -13 24) (patch -11 24) (patch -9 24) (patch -7 24) (patch -5 24) (patch -3 24) (patch -1 24) (patch 1 24) (patch 3 24) (patch 5 24) (patch 7 24) (patch 9 24) (patch 11 24) (patch 13 24) (patch 15 24) (patch 17 24) (patch 19 24) (patch -19 25) (patch -17 25) (patch -15 25) (patch -13 25) (patch -11 25) (patch -9 25) (patch -7 25) (patch -5 25) (patch -3 25) (patch -1 25) (patch 1 25) (patch 3 25) (patch 5 25) (patch 7 25) (patch 9 25) (patch 11 25) (patch 13 25) (patch 15 25) (patch 17 25) (patch 19 25) (patch -19 26) (patch -17 26) (patch -15 26) (patch -13 26) (patch -11 26) (patch -9 26) (patch -7 26) (patch -5 26) (patch -3 26) (patch -1 26) (patch 1 26) (patch 3 26) (patch 5 26) (patch 7 26) (patch 9 26) (patch 11 26) (patch 13 26) (patch 15 26) (patch 17 26) (patch 19 26) (patch -19 27) (patch -17 27) (patch -15 27) (patch -13 27) (patch -11 27) (patch -9 27) (patch -7 27) (patch -5 27) (patch -3 27) (patch -1 27) (patch 1 27) (patch 3 27) (patch 5 27) (patch 7 27) (patch 9 27) (patch 11 27) (patch 13 27) (patch 15 27) (patch 17 27) (patch 19 27) (patch -19 28) (patch -17 28) (patch -15 28) (patch -13 28) (patch -11 28) (patch -9 28) (patch -7 28) (patch -5 28) (patch -3 28) (patch -1 28) (patch 1 28) (patch 3 28) (patch 5 28) (patch 7 28) (patch 9 28) (patch 11 28) (patch 13 28) (patch 15 28) (patch 17 28) (patch 19 28) (patch -19 29) (patch -17 29) (patch -15 29) (patch -13 29) (patch -11 29) (patch -9 29) (patch -7 29) (patch -5 29) (patch -3 29) (patch -1 29) (patch 1 29) (patch 3 29) (patch 5 29) (patch 7 29) (patch 9 29) (patch 11 29) (patch 13 29) (patch 15 29) (patch 17 29) (patch 19 29) (patch -19 30) (patch -17 30) (patch -15 30) (patch -13 30) (patch -11 30) (patch -9 30) (patch -7 30) (patch -5 30) (patch -3 30) (patch -1 30) (patch 1 30) (patch 3 30) (patch 5 30) (patch 7 30) (patch 9 30) (patch 11 30) (patch 13 30) (patch 15 30) (patch 17 30) (patch 19 30))
  set sidewalk-list4 (patch-set (patch -19 -21) (patch -17 -21) (patch -15 -21) (patch -13 -21) (patch -11 -21) (patch -9 -21) (patch -7 -21) (patch -5 -21) (patch -3 -21) (patch -1 -21) (patch 1 -21) (patch 3 -21) (patch 5 -21) (patch 7 -21) (patch 9 -21) (patch 11 -21) (patch 13 -21) (patch 15 -21) (patch 17 -21) (patch 19 -21) (patch -19 -22) (patch -17 -22) (patch -15 -22) (patch -13 -22) (patch -11 -22) (patch -9 -22) (patch -7 -22) (patch -5 -22) (patch -3 -22) (patch -1 -22) (patch 1 -22) (patch 3 -22) (patch 5 -22) (patch 7 -22) (patch 9 -22) (patch 11 -22) (patch 13 -22) (patch 15 -22) (patch 17 -22) (patch 19 -22) (patch -19 -23) (patch -17 -23) (patch -15 -23) (patch -13 -23) (patch -11 -23) (patch -9 -23) (patch -7 -23) (patch -5 -23) (patch -3 -23) (patch -1 -23) (patch 1 -23) (patch 3 -23) (patch 5 -23) (patch 7 -23) (patch 9 -23) (patch 11 -23) (patch 13 -23) (patch 15 -23) (patch 17 -23) (patch 19 -23) (patch -19 -24) (patch -17 -24) (patch -15 -24) (patch -13 -24) (patch -11 -24) (patch -9 -24) (patch -7 -24) (patch -5 -24) (patch -3 -24) (patch -1 -24) (patch 1 -24) (patch 3 -24) (patch 5 -24) (patch 7 -24) (patch 9 -24) (patch 11 -24) (patch 13 -24) (patch 15 -24) (patch 17 -24) (patch 19 -24) (patch -19 -25) (patch -17 -25) (patch -15 -25) (patch -13 -25) (patch -11 -25) (patch -9 -25) (patch -7 -25) (patch -5 -25) (patch -3 -25) (patch -1 -25) (patch 1 -25) (patch 3 -25) (patch 5 -25) (patch 7 -25) (patch 9 -25) (patch 11 -25) (patch 13 -25) (patch 15 -25) (patch 17 -25) (patch 19 -25) (patch -19 -26) (patch -17 -26) (patch -15 -26) (patch -13 -26) (patch -11 -26) (patch -9 -26) (patch -7 -26) (patch -5 -26) (patch -3 -26) (patch -1 -26) (patch 1 -26) (patch 3 -26) (patch 5 -26) (patch 7 -26) (patch 9 -26) (patch 11 -26) (patch 13 -26) (patch 15 -26) (patch 17 -26) (patch 19 -26) (patch -19 -27) (patch -17 -27) (patch -15 -27) (patch -13 -27) (patch -11 -27) (patch -9 -27) (patch -7 -27) (patch -5 -27) (patch -3 -27) (patch -1 -27) (patch 1 -27) (patch 3 -27) (patch 5 -27) (patch 7 -27) (patch 9 -27) (patch 11 -27) (patch 13 -27) (patch 15 -27) (patch 17 -27) (patch 19 -27) (patch -19 -28) (patch -17 -28) (patch -15 -28) (patch -13 -28) (patch -11 -28) (patch -9 -28) (patch -7 -28) (patch -5 -28) (patch -3 -28) (patch -1 -28) (patch 1 -28) (patch 3 -28) (patch 5 -28) (patch 7 -28) (patch 9 -28) (patch 11 -28) (patch 13 -28) (patch 15 -28) (patch 17 -28) (patch 19 -28) (patch -19 -29) (patch -17 -29) (patch -15 -29) (patch -13 -29) (patch -11 -29) (patch -9 -29) (patch -7 -29) (patch -5 -29) (patch -3 -29) (patch -1 -29) (patch 1 -29) (patch 3 -29) (patch 5 -29) (patch 7 -29) (patch 9 -29) (patch 11 -29) (patch 13 -29) (patch 15 -29) (patch 17 -29) (patch 19 -29) (patch -19 -30) (patch -17 -30) (patch -15 -30) (patch -13 -30) (patch -11 -30) (patch -9 -30) (patch -7 -30) (patch -5 -30) (patch -3 -30) (patch -1 -30) (patch 1 -30) (patch 3 -30) (patch 5 -30) (patch 7 -30) (patch 9 -30) (patch 11 -30) (patch 13 -30) (patch 15 -30) (patch 17 -30) (patch 19 -30))
  set sidewalk-list5 (patch-set (patch -19 -19) (patch -19 19) (patch -17 -17) (patch -17 17) (patch -15 -15) (patch -15 15) (patch -13 -13) (patch -13 13) (patch -11 -11) (patch -11 11) (patch -9 -9) (patch -9 9) (patch -7 -7) (patch -7 7) (patch -5 -5) (patch -5 5) (patch -3 -3) (patch -3 3) (patch -1 -1) (patch -1 1) (patch 19 -19) (patch 19 19) (patch 17 -17) (patch 17 17) (patch 15 -15) (patch 15 15) (patch 13 -13) (patch 13 13) (patch 11 -11) (patch 11 11) (patch 9 -9) (patch 9 9) (patch 7 -7) (patch 7 7) (patch 5 -5) (patch 5 5) (patch 3 -3) (patch 3 3) (patch 1 -1) (patch 1 1))
  ask sidewalk-list1 [set pcolor white]
  ask sidewalk-list2 [set pcolor white]
  ask sidewalk-list3 [set pcolor white]
  ask sidewalk-list4 [set pcolor white]
  if diagonals = true [ask sidewalk-list5  [set pcolor white]]
 ask turtles
  [
    if color = red [setxy (min-pxcor + random-float 9.0) (min-pycor + random-float 9.0)]
    if color = blue [setxy (max-pxcor - random-float 9.0) (min-pycor + random-float 9.0)]
    if color = green [setxy (max-pxcor - random-float 9.0) (max-pycor - random-float 9.0)]
    if color = yellow [setxy (min-pxcor + random-float 9.0) (max-pycor - random-float 9.0)]
  ]
  set red-crossed false
  set blue-crossed false
  set yellow-crossed false
  set green-crossed false
  reset-ticks
end

to go
  if count turtles with [color = red] = 0 and red-crossed = false [output-type "All Red Agents Crossed at " output-print ticks set red-crossed true]
  if count turtles with [color = blue] = 0 and blue-crossed = false [output-type "All Blue Agents Crossed at " output-print ticks set blue-crossed true]
  if count turtles with [color = yellow] = 0 and yellow-crossed = false [output-type "All Yellow Agents Crossed at " output-print ticks set yellow-crossed true]
  if count turtles with [color = green] = 0 and green-crossed = false [output-type "All Green Agents Crossed at " output-print ticks set green-crossed true]
  if count turtles = 0 or ticks = stoptime [stop]
  ask turtles
  [
    if color = red and pcolor = pink [die]
    if color = blue and pcolor = turquoise [die]
    if color = yellow and pcolor = orange [die]
    if color = green and pcolor = lime [die]
  ] ; when a pedestrian has reached their final destination, it will die
  evaluate-type
  check-direction
  tick
end

to evaluate-type
  ask turtles
  [
    if color = red
    [
      if agent-type-r = "relaxed" [check-density-relaxed]
      if agent-type-r = "rebellious" [check-density-rebel]
      if agent-type-r = "hurried" [check-density-hurried]
      if agent-type-r = "passive" [check-density-passive]
    ]
   if color = blue
    [
      if agent-type-b = "relaxed" [check-density-relaxed]
      if agent-type-b = "rebellious" [check-density-rebel]
      if agent-type-b = "hurried" [check-density-hurried]
      if agent-type-b = "passive" [check-density-passive]
    ]
   if color = green
    [
      if agent-type-g = "relaxed" [check-density-relaxed]
      if agent-type-g = "rebellious" [check-density-rebel]
      if agent-type-g = "hurried" [check-density-hurried]
      if agent-type-g = "passive" [check-density-passive]
    ]
   if color = yellow
    [
      if agent-type-y = "relaxed" [check-density-relaxed]
      if agent-type-y = "rebellious" [check-density-rebel]
      if agent-type-y = "hurried" [check-density-hurried]
      if agent-type-y = "passive" [check-density-passive]
    ]
  ]
end

to check-density-relaxed
  ask self [
    if count turtles in-cone-nowrap 4 90 >= (25) [ifelse random-float 1.0 <= 0.5 [right random-normal 22.5 22.5 fd .5] [left random-normal 22.5 22.5 fd .5]]
    if count turtles in-cone-nowrap 4 90 >= (10) [ifelse random-float 1.0 <= 0.5 [right random-normal 22.5 22.5 fd 1] [left random-normal 22.5 22.5 fd 1]]
    if count turtles in-cone-nowrap 4 90 < (10) [fd random-normal 0.75 0.25]
  ]
end

to check-density-rebel
  set shortcut-value random-normal 30 5
  ask self [
  if count turtles with [color = [color] of self] in-radius 5 >= (25) [ifelse random-float 1.0 <= 0.5 [right random-normal 22.5 22.5] [left random-normal 22.5 22.5]]
  ifelse random-float 1.0 <= 0.8 and pcolor = white
  [
    if color = red [facexy max-pxcor max-pycor fd random-normal 0.75 0.25]
    if color = blue [facexy min-pxcor max-pycor fd random-normal 0.75 0.25]
    if color = yellow [facexy max-pxcor min-pycor fd random-normal 0.75 0.25]
    if color = green [facexy min-pxcor min-pycor fd random-normal 0.75 0.25]
  ]
  [fd random-normal 1 0.25]
  ]
end

to check-density-hurried
  ask self [
    if count turtles in-cone-nowrap 6 120 >= (25) [ifelse random-float 1.0 <= 0.5 [right random-normal 22.5 22.5 fd .5] [left random-normal 22.5 22.5 fd .5]]
    if count turtles in-cone-nowrap 6 120 >= (10) [ifelse random-float 1.0 <= 0.5 [right random-normal 22.5 22.5 fd 1] [left random-normal 22.5 22.5 fd 1]]
    if count turtles in-cone-nowrap 6 120 < (10) [fd 1.5]
  ]
end

to check-density-passive
  ask self
  [
    ifelse count turtles in-radius 3 >= (35)
    [face min-one-of patches in-radius 5 [count turtles] fd random-normal 1.25 0.25]
    [fd random-normal 1 0.25]
  ]
end

to check-direction
  if diagonals = true [
  ask turtles
  [
    if color = green [
      facexy min-pxcor min-pycor ; Face towards lime quadrant
    ]
    if color = yellow [
      facexy max-pxcor min-pycor ; Face towards orange quadrant
    ]
    if color = blue [
      facexy min-pxcor max-pycor ; Face towards turquoise quadrant
    ]
    if color = red [
      facexy max-pxcor max-pycor ; Face towards pink quadrant
    ]
  ]
]
  if diagonals = false [
  ask turtles with [color = green]
    [
      ifelse distance (patch min-pxcor max-pycor) < distance (patch max-pxcor min-pycor)
          [facexy min-pxcor max-pycor] ; Move towards turquoise (left)
          [facexy max-pxcor min-pycor] ; Move towards orange (down)
      if (xcor < (min-pxcor + 9)) or (ycor < min-pycor + 9) ; After reaching respective intermediate destinations...
        [facexy min-pxcor min-pycor] ; ...Face towards lime quadrant.
      if agent-type-g = "rebellious" and ((xcor < min-pxcor + shortcut-value) or (ycor < min-pycor + shortcut-value))
        [facexy min-pxcor min-pycor]
    ]
  ask turtles with [color = yellow]
    [
      ifelse distance (patch max-pxcor max-pycor) < distance (patch min-pxcor min-pycor)
        [facexy max-pxcor max-pycor] ; Face towards pink quadrant (right)
        [facexy min-pxcor min-pycor] ; Face towards lime quadrant (down)
      if (xcor > (max-pxcor - 9)) or (ycor < min-pycor + 9) ; After reaching respective intermediate destinations...
        [facexy max-pxcor min-pycor] ; ...Face towards orange quadrant
      if agent-type-y = "rebellious" and ((xcor > max-pxcor - shortcut-value) or (ycor < min-pycor + shortcut-value))
        [facexy max-pxcor min-pycor]
    ]
  ask turtles with [color = blue]
    [
      ifelse distance (patch max-pxcor max-pycor) < distance (patch min-pxcor min-pycor)
        [facexy max-pxcor max-pycor] ; Face towards pink quadrant (up)
        [facexy min-pxcor min-pycor] ; Face towards lime quadrant (left)
      if (xcor < (min-pxcor + 9)) or (ycor > max-pycor - 9) ; After reaching respective intermediate destinations...
        [facexy min-pxcor max-pycor] ; ...Face towards turquoise quadrant
      if agent-type-b = "rebellious" and ((xcor < min-pxcor + shortcut-value) or (ycor > max-pycor - shortcut-value))
        [facexy min-pxcor max-pycor]
    ]
  ask turtles with [color = red]
    [
      ifelse distance (patch min-pxcor max-pycor) < distance (patch max-pxcor min-pycor)
        [facexy min-pxcor max-pycor] ; Face towards turquoise (up)
        [facexy max-pxcor min-pycor] ; Face towards orange (right)
      if (xcor > (max-pxcor - 9)) or (ycor > max-pycor - 9) ; After reaching respective intermediate destinations...
        [facexy max-pxcor max-pycor] ; ...Face towards pink quadrant
      if agent-type-r = "rebellious" and ((xcor > max-pxcor - shortcut-value) or (ycor > max-pycor - shortcut-value))
        [facexy max-pxcor max-pycor]
    ]
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
501
10
988
498
-1
-1
7.8525
1
10
1
1
1
0
0
0
1
-30
30
-30
30
1
1
1
ticks
30.0

BUTTON
35
17
99
50
setup
setup
NIL
1
T
OBSERVER
NIL
Z
NIL
NIL
1

BUTTON
115
18
178
51
go
go\n
T
1
T
OBSERVER
NIL
X
NIL
NIL
1

SWITCH
21
60
188
93
diagonals
diagonals
1
1
-1000

CHOOSER
17
103
190
148
agent-type-r
agent-type-r
"relaxed" "rebellious" "hurried" "passive"
1

CHOOSER
16
161
191
206
agent-type-b
agent-type-b
"relaxed" "rebellious" "hurried" "passive"
1

CHOOSER
16
218
193
263
agent-type-g
agent-type-g
"relaxed" "rebellious" "hurried" "passive"
1

CHOOSER
15
276
188
321
agent-type-y
agent-type-y
"relaxed" "rebellious" "hurried" "passive"
1

SLIDER
16
330
188
363
pedestrians
pedestrians
100
400
400.0
4
1
NIL
HORIZONTAL

PLOT
1000
15
1483
377
Number of Pedestrians in Crosswalk
 Time Elapsed (ticks)
Number of Pedestrians
0.0
10.0
0.0
100.0
true
true
"" ""
PENS
"Red Agents" 1.0 0 -2674135 true "" "plot count turtles with [color = red]"
"Blue Agents" 1.0 0 -13345367 true "" "plot count turtles with [color = blue]"
"Yellow Agents" 1.0 0 -1184463 true "" "plot count turtles with [color = yellow]"
"Green Agents" 1.0 0 -10899396 true "" "plot count turtles with [color = green]"

OUTPUT
196
12
496
369
12

SLIDER
16
375
188
408
stoptime
stoptime
0
200
102.0
1
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

This is an agent-based model intended to demonstrate the function of scramble crossings and establish a more efficient flow of pedestrian traffic with the presence of diagonal crosswalks measured by travel times. 

## HOW IT WORKS

After initializing this model with the SETUP button, the agents/pedestrians are separated into 4 different colors: red, blue, yellow, and green. The color-coded agents spawn inside quadrants that are farthest from their destinations and thereafter diffuse slightly within their quadrant. For instance, the red agents are attempting to reach the pink quadrant at the top right quadrant but are initially spawned at the bottom left quadrant (lime). Similarly, yellow agents are heading toward the orange quadrant, blue agents are heading toward the turquoise quadrant, and the green agents are heading toward the lime quadrant. Depending on the option selected for the "diagonals" parameter prior to setting up, a series of diagonal white patches across which the agents can walk appear as well.

Pressing GO will run the model and allow the pedestrians to start moving toward their respective destinations. If the "diagonal" switch is set to ON before intialization, all agents will travel diagonally across the crosswalk in order to reach their destinations. Otherwise, each agent are given a 50/50 chance to travel to one of two intermediate quadrants and travel to their final destination from there. For instance, the red agents may choose to either travel upwards to the turquoise quadrant or right to orange quadrant  in various ways depending on the choice of the agent-type-(color) Choosers before initialization.

__*Agent Movement Types*__

Described here are the different movement styles/rules that a type of agent follows.

* __Relaxed Movement:__ Agents with this type of movement attempt to reflect real-life pedestrians who are travelling in a relaxed manner. They travel at a regular walking pace (slower than those who are in a hurry with the Hurried Movement style) and observe how many other pedestrians are within 4 patches of the individual agent with a normal scope of vision (45 degrees to the left and right). Depending on the number of agents in front of an individual agent with this movement type, they will attempt to swerve out of the way to avoid collisions. In addition, their walking speed can also fluctuate depending on the number of agents within this scope of vision.

* __Rebellious Movement:__ Agents with this type of movement serve as malicious actors to the real-life pedestrian crossing process. In the context of this model, these rebels will attempt to take a shortcut by not heading toward their intermediate quadrants before heading towards their final destinations when no diagonals are present, essentially providing them the opportunity to create a diagonal path of their own. Whether an agent of this type follows the traditional path or form a new diagonal path is made whenever an agent of this type is above any white patch of a vertical or horizontal crosswalk with a 90% chance of forming a diagonal path. In addition, these rebels do not record the number of agents in front of them, meaning that they can freely collide with other agents without harming their own progress.

* __Hurried Movement:__ Agents with this type of movement reflect real-life pedestrians who happen to be in a hurry. As such, these agents travel at the fastest pace out of all of the movement styles and need to react to the presence of agents at a farther distance and than that of agents with relaxed movement. As aresult, they measure the number of agents within 6 patches as opposed to 4. In addition, these agents are provided a larger scope of vision from which to count the number of agents in front of them in order for them to react quicker (60 degrees to the left and right).

* __Passive Movement:__ Agents with this type of movement try to look for the optimal path with the least amount of collisions with not only other agent types but also other agents that share this movement style, and they reflect real-life pedestrians who may be overwhelmed by the sheer amount of foot traffic in scramble crossings. For an individual agent to calculate such path, they first need a scenario where at least 35 other agents are within 3 patches of itself. From there, it now changes its bearing from facing the final destination to facing the nearest patch with the least amount of agents within 5 patches of itself. Their range of walking pace is set to be the same as that of the relaxed agent, regardless of the number of other agents within 3 patches of an agent with this movement type.

## HOW TO USE IT

The SETUP button initializes the model.

The GO button runs the model.

Immediately below the SETUP and GO buttons is a Chooser titled DIAGONALS that selects whether or not a diagonal path is added during initialization. 

From there, 4 Choosers are provided establish the movement types of the red, blue, yellow, and green agents, respectively, during intialization.

Next is the PEDESTRIANS slider that adjusts the total number of agents spawned during initalization. The number of agents need to be divided equally into four groups, so this slider ranges from 100 to 400, incrementing by 4 per step.

Finally, the STOPTIME slider dictates the maximum number of ticks that the agents have to complete crossing. The model will stop when all agents have crossed or the number of ticks is equal to the value of the STOPTIME slider, whichever comes first. 

## THINGS TO NOTICE

To the left of the model is an output screen that informs when a group of colored agents has finished crossing. If all the agents that share a color have not finished crossing by the tick value of STOPTIME, nothing about that color will be mentioned on the screen by the end of a run of this model. This screen allows to note when an agent type fully completes the crossing with respect to other agent types.

To the right of the model is a graph that informs the number of agents of a certain color that has yet to fully complete their crossing for any given tick. This graph will allow to view the rate at which each agent type completes crossing throughout a run of this model.

## THINGS TO TRY

Provided that all agents possess the same movement style (e.g. all four agent groups move under the Rebellious Movement rule), try to find the minimum amount of ticks for all agents to complete crossing. Also try to perform this both with and without the use of a diagonal.

Given a certain arrangement of agents and movement types, try adjusting the number of pedestrians to see how the number of ticks for all agents to complete crossing changes. Try this both with and without the use of a diagonal.

## EXTENDING THE MODEL

Unlike traditional agent-based models, each individual agent in this model does not have the ability to adapt to their surroundings aside from avoiding collisions with other agents. Each agent is unable change their movement styles based on their surroundings; rather, their movement styles are fixed to a group of individuals during initialization and do not change their movement styles under any circumstances during a run. Implementing the ability for individual agents to change their movement styles (e.g. if a relaxed agent sees more than 50 agents clumped together in front of them, that agent may consider turning "rebellious" and implement a shortcut on their own) can make this model a more accurate representation of pedestrian scrambles. How would the minimum ticks taken for all agents to cross change under such change to the current code?

In addition, the circumstances of this pedestrian scramble model assumes the "worst case scenario" where every agent has to travel to the farthest quadrant as their final destinations as opposed to making any intermediate quadrants their final destination. Such change can be theoretically implemented by providing agents three choices of going vertically to an intermediate quadrant, going horizontally to an intermediate quadrant, or going diagonally to their final quadrant with each agent having a 1/3 chance of deciding on one choice ina  run with diagonals enabled. Once again, how would the minimum ticks taken for all agents to cross change under such change to the current code?

This current model is also limited in the sense that it is only capable of having 400 moving agents/pedestrians at one time. Japan's Shibuya Crossing, the world's busiest pedestrian scramble crossing, can see up to 3,000 pedestrians crossing at once. Would the minimum ticks taken for all agents to cross change if more than 400 pedestrians were crossing at one time?

## NETLOGO FEATURES

This model makes heavy use of random number generation, but when a random number between a certain range of values is desired in our model, the `random-normal` primitive is one method of producing such values. This particular primitive reports a normally distributed random floating point number around an average value and a standard deviation.

## RELATED MODELS

Braess Paradox: Located in the Social Science suite of models in NetLogo, this serves as the main reference for the Pedestrian Scramble model. The phenomenon behind the Braess Paradox model suggests that implementing additional routes to a traffic network actually leads to worse individual and global outcomes (i.e. travel times) as opposed to improving traffic. The phenomenon that drives our model differs from that behind the Braess Paradox, however, suggesting how adding routes can improve certain types of traffic. 

## CREDITS AND REFERENCES

Information on the Pedestrian Scramble: https://www.wise-geek.com/what-is-the-pedestrian-scramble.htm

Information on Shibuya Crossing: https://web.archive.org/web/20200812012537/https://www.worldatlas.com/articles/what-is-the-world-s-busiest-pedestrian-crossing.html

Rasmussen, L. and Wilensky, U. (2019). NetLogo Braess Paradox model. http://ccl.northwestern.edu/netlogo/models/BraessParadox. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

Wilensky, U. (1999). NetLogo. http://ccl.northwestern.edu/netlogo/. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.2.0
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
